Page MenuHomePhabricator

Clarify how the "Enable quick topic adding" setting affects creating new talk pages (separate setting?)
Closed, ResolvedPublic

Description

This task represents the work involved with adjusting how the the Enable quick topic adding setting in Special:Preferences#mw-prefsection-editing#discussion-pages interacts with the standard/legacy form that appears when people click a [red] link to a talk page that does not yet exist.

User Story

  • When I, a Senior Contributor who has the Enable quick topic adding setting enabled, click on a red-linked talk page (or otherwise arrive at a talk page that has not yet been created), I want a fast and easy way to access the full-page, source editor, so that I can create said talk page by adding a template to the page (read: without starting a new topic).

Requirements

We will introduce a new setting that enables people to choose the experience they have when they arrive on a talk page that has not yet been created. That setting should be implemented as follows:

  • Setting should always be visible regardless of state of enable quick topic adding setting
  • IF enable quick topic adding setting is disabled, so too should this new setting
  • New setting should have two options, each prefixed with a radio button

Minimum test case

  1. Visit a wiki where the New Discussion Tool is available
  2. Log in
  3. Visit Special:Preferences#mw-prefsection-editing#discussion-pages
  4. Verify that a new preference appears specified in the ===Requirements section above
  5. Verify that changing the preference has the expected effect whe visiting a talk page that does not exist

Done

  • Implement === Requirements
  • Update or remove local override for the preference help text on English Wikipedia, to better match the new behavior

References

Conversation on MediaWiki where @Xaosflux first raised this issue: Topic:Wiggfwdwlg1hu8be.

Event Timeline

ppelberg added a subscriber: Whatamidoing-WMF.

Note: I've updated the task description with some initial copy @Whatamidoing-WMF suggested here: Topic:Wiggfwdwlg1hu8be.

ppelberg renamed this task from Improve clarify of "Enable quick topic adding" setting to Improve clarity of "Enable quick topic adding" setting.Dec 18 2021, 2:07 AM

While I'm all for making sure the label is as informative as possible, is it necessary that this "topic adding" tool take over "new page creation" workflows as well?

I think we might have to add a preference to choose whether the new topic tool should replace the standard editor when creating new talk pages, rather than just clarify that it does. There is a large group of users whose talk page creations are exclusively non-comments (that is, Wikiproject templates etc). There is also a large group of users whose talk page creations are exclusively comments.

We could tell the first group to disable the new topic tool entirely, but I don't think we want them to not have access to it when they're commenting on existing pages.


I've tried to visualize this: (data: https://quarry.wmcloud.org/query/61355)

enwikidewikiplwiki
image.png (680×1 px, 46 KB)
image.png (680×1 px, 42 KB)
image.png (680×1 px, 36 KB)

It's also quite different on different wikis:

  • On enwiki, about 30% of users exclusively create talk pages by adding a new comment, about 30% of exclusively create them by adding non-comments, and the rest do both.
  • On dewiki, about 40% of users exclusively create talk pages by adding a new comment, and almost no one exclusively creates them by adding non-comments.
  • On plwiki, almost no one exclusively creates talk pages by adding non-comments, and about 50% exclusively create them by adding non-comments.

(Only counting page creations by logged-in users who made >5 of them, within last month. Also, this excludes bots, but includes various tools like Twinkle; it'd be more difficult to exclude those, but I don't think that matters much here.)

matmarex renamed this task from Improve clarity of "Enable quick topic adding" setting to Improve clarity of "Enable quick topic adding" setting (separate setting for creating new talk pages?).Jan 7 2022, 11:01 PM

Change 752227 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/DiscussionTools@master] Add preference for new topic tool when creating new talk pages

https://gerrit.wikimedia.org/r/752227

Test wiki created on Patch demo by PPelberg (WMF) using patch(es) linked to this task:

https://patchdemo.wmflabs.org/wikis/c4872cba5f/w/

image.png (144×388 px, 19 KB)

My thoughts:

  • We should disable the sub-option when the main option is not selected, not hide it, to avoid the height jump (change 'hide-if' to 'disable-if')
  • I think the second option being a radio makes it more confusing, I think just a simple checkbox with "Enable quick topic adding when creating new pages" would suffice (with some help text explaining it replaces the editor)
  • The sub-option should be indented

I'd like us to discuss this (particularly the preference I proposed in T297990#7606561) before wider deployment.

matmarex renamed this task from Improve clarity of "Enable quick topic adding" setting (separate setting for creating new talk pages?) to Clarify how the "Enable quick topic adding" setting affects creating new talk pages (separate setting?).May 31 2022, 6:24 PM
  • We should disable the sub-option when the main option is not selected, not hide it, to avoid the height jump (change 'hide-if' to 'disable-if')

I see your point, but we also use hiding for other preferences, like how "Enable editing tools in source mode" disappears if you disable the reply and new topic tool. (Maybe we should change them all…)

  • I think the second option being a radio makes it more confusing, I think just a simple checkbox with "Enable quick topic adding when creating new pages" would suffice (with some help text explaining it replaces the editor)

I thought that this works better as two separate options rather than just a checkbox, because you're not really just "disabling" a thing, but rather choosing between two behaviors. Both the new topic tool and the wikitext editor are still available in both cases – the choice is just about which one appears when you click on a red link.

Also note that this isn't really about the new topic tool by itself – it's about the "empty state" thing that appears instead of a note that the page doesn't exist. It seemed too complicated to explain in a single checkbox label.

  • The sub-option should be indented

I'm afraid we don't have a good way to do this for preferences.

  • The sub-option should be indented

I'm afraid we don't have a good way to do this for preferences.

Preference options are passed to HTMLForm, so you could just add a cssclass key, although I supposed the actual CSS would need to be upstream.

I made changes to the patch per the discussion today (added indent, made it disable instead of hide), and updated the description here.

Change 752227 merged by jenkins-bot:

[mediawiki/extensions/DiscussionTools@master] Add preference for offering new topic tool when creating new talk pages

https://gerrit.wikimedia.org/r/752227

Change 803527 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/DiscussionTools@wmf/1.39.0-wmf.14] Add preference for offering new topic tool when creating new talk pages

https://gerrit.wikimedia.org/r/803527

EAkinloose added a subscriber: EAkinloose.

Setting is visible regardless of state of enable quick topic adding setting
IF enable quick topic adding setting is disabled, the new setting stay disabled too
New setting has two options, each prefixed with a radio button
See below

Screenshot 2022-06-07 at 15.58.53.png (1×1 px, 224 KB)

Screenshot 2022-06-07 at 15.59.05.png (1×1 px, 232 KB)

When the Offer to add a new topic option is selected

Screenshot 2022-06-07 at 16.10.10.png (964×2 px, 201 KB)

When the Open the wikitext editor option is selected

Screenshot 2022-06-07 at 16.15.11.png (990×1 px, 219 KB)

Screenshot 2022-06-07 at 16.14.46.png (1×1 px, 224 KB)

Screenshot 2022-06-07 at 15.58.53.png (1×1 px, 224 KB)

This is a bit confusing for me. Is it possible to force selecting the second option (full-page editor) if the New Topic Tool is off? Because that’s what actually happens. If it’s not possible or is too much work, maybe the setting copy could stress that turning off the New Topic Tool causes the second option to apply. (Especially as it wouldn’t be even technically necessary: action=edit&redlink=1 could present the same form as action=edit&section=new instead of the same form as action=edit if we wanted it to. Yes, core changes would be necessary, and it probably wouldn’t be worth it, but users could well expect this to happen.)

Change 803527 merged by jenkins-bot:

[mediawiki/extensions/DiscussionTools@wmf/1.39.0-wmf.14] Add preference for offering new topic tool when creating new talk pages

https://gerrit.wikimedia.org/r/803527

Mentioned in SAL (#wikimedia-operations) [2022-06-07T20:53:23Z] <urbanecm@deploy1002> Finished scap: DiscussionTools backports + r803526 (T310053, T297990) (duration: 24m 43s)

Update or remove local override for the preference help text on English Wikipedia, to better match the new behavior

https://en.wikipedia.org/wiki/MediaWiki_talk:Discussiontools-preference-newtopictool-help

Screenshot 2022-06-07 at 15.58.53.png (1×1 px, 224 KB)

This is a bit confusing for me. Is it possible to force selecting the second option (full-page editor) if the New Topic Tool is off? Because that’s what actually happens.

Not possible in the current preferences system :(

If it’s not possible or is too much work, maybe the setting copy could stress that turning off the New Topic Tool causes the second option to apply. (Especially as it wouldn’t be even technically necessary: action=edit&redlink=1 could present the same form as action=edit&section=new instead of the same form as action=edit if we wanted it to. Yes, core changes would be necessary, and it probably wouldn’t be worth it, but users could well expect this to happen.)

Test wiki on Patch demo by PPelberg (WMF) using patch(es) linked to this task was deleted:

https://patchdemo.wmflabs.org/wikis/c4872cba5f/w/